import { PlayerMoveSide, PlayerMoveSideType } from '../../constants';
import { AbstractPlayer } from './AbstractPlayer';
import { Board } from '../Board';
import { PlayerMove } from '../PlayerMove';
import { Tile } from '../Tile';
import { PlayerInteractionConsole } from '../../PlayerInteractionConsole';
import { PlayerInteractionInterface } from '../../PlayerInteractionInterface';

export class PlayerHuman extends AbstractPlayer {
  playerInteraction: PlayerInteractionInterface = new PlayerInteractionConsole(this);
  constructor(name: string) {
    super(name);
  }

  async makeMove(board: Board): Promise<PlayerMove | null> {    
    return await this.playerInteraction.makeMove(board);   
  }

  async chooseTile(board: Board): Promise<Tile> {
    return this.playerInteraction.chooseTile(board);
  }
}