import { PlayerInteractionInterface } from "../../PlayerInteractionInterface";
import { Board } from "../Board";
import { GameState } from "../../dto/GameState";
import { PlayerMove } from "../PlayerMove";
import { PlayerState } from "../../dto/PlayerState";
import { Tile } from "../Tile";
import { GameSessionState } from "../../dto/GameSessionState";

export interface PlayerInterface {
  id: string;
  name: string;
  score: number;
  hand: Tile[];
  teamedWith: PlayerInterface | null;
  playerInteraction: PlayerInteractionInterface;

  makeMove(gameState: Board): Promise<PlayerMove | null>;
  chooseTile(board: Board): Promise<Tile>;
  pipsCount(): number;
  notifyGameState(state: GameState): Promise<void>;
  notifyPlayerState(state: PlayerState): Promise<void>;
  notifySessionState(state: GameSessionState): Promise<void>;
  getState(): PlayerState;
}