import express from 'express';
import http from 'http';
import cors from 'cors';
import { join } from 'path';

import { NetworkClientNotifier } from '../game/NetworkClientNotifier';
import { SocketIoService } from './services/SocketIoService';

const clientNotifier = new NetworkClientNotifier();
const app = express();
const httpServer = http.createServer(app);
const socketIoService = new SocketIoService(httpServer);
clientNotifier.setSocket(socketIoService.getServer());

const PORT = process.env.PORT || 3000;
console.log('__dirname :>> ', __dirname);

app.use(cors());
app.get('/', (req, res) => {
  res.sendFile(join(__dirname, 'index.html'));
});

httpServer.listen(PORT, () => {
  console.log(`listening on *:${PORT}`);
});
